to 21.5.16 "celeriac"

Build

-- Don't detect GNU DLD - James.
-- Better detection of sound on Solaris9 - Buchholz.
-- Add support detecting SunOS 5.10 in configure - Buchholz.
-- Use '-bundle' when testing ability to build shared libs, but use
     '-bundle_loader' in ellcc - Begel.
-- Output separate declaration and definition for dump_id - James.
-- Add Makefile targets to build PDF docs - Wambold.
-- Don't mangle the unload function in `unload_postgresql' and
     `unload_ldap' when compiling with C++ - James.
-- Use extern "C" for C++ builds - James.
-- Conditionally compile messages missing from the Cygwin headers - James.
-- Add cast to quiet compiler in unexcw.c - James.
-- Quiet compiler warnings about struct stat in syswindows.h - James.
-- Test \{m,n\} in regexp-tests - Turnbull.

Documentation

-- Propose bash as workaround for buggy Solaris sh in PROBLEMS - Sparapani.
-- Fix the PRINTED-MANUAL-TITLE arg for cross ref to "The XEmacs User's Manual"
     - Aichner.
-- New node: "A Reader's Guide to XEmacs Coding Conventions" - Turnbull.
-- New node: "Customizing Message Display" - Golubev.

Internals

-- In ellcc.c don't mangle external symbols in generated doc file - James.
-- Add PARTIALLY parameter to support Fpos_visible_in_window_p parameter in
     redisplay - James.
-- Use 'point_would_be_visible' parameter in `scrollbar_reset_cursor' - James.
-- Add PARTIALLY parameter fo `Fpos_visible_in_window_p' - James.
-- Use new 'point_would_be_visible' parameter in `window_scroll' - James.
-- dll_open now takes a Lisp_Object - James.
-- Remove useless call to dll_init - James.
-- char to CIbyte conversion in emodules.c, sysdll.c - James.
-- Do not mangle module initialisation function names - James.
-- char to Extbyte conversion in sysdll.c - James.
-- Return a Lisp_Object instead of a string in `dll_error' - James.
-- Make eval-related functions visible to modules - James.
-- Allow specifying elisp function for waithing user input while displaying
     message while in minibuffer - Golubev.
-- Use OS_RELEASE=os_release_major*100+os_release_minor in s/sol2.h - Buchholz.
-- Add lrecord_memory_descriptions - Crestani.
-- Remove GetLongPathNameW - Harris.
-- A couple of new macros to compare w32api versions - James.
-- KKCC fixes - Crestani.

Lisp API

-- Allow user to specify alternative function for displaying message - Golubev.
-- New var to specify the maximum received fonts - LewisMoss.
-- Allow gnuserv to fallback to GTK if X device fails - LewisMoss.
-- Eval the initialisation value of `eol-detection-enabled-p' - Alexander.
-- Make sure `setbuffer-file-coding-system' sets the eol type - Alexander.
-- Remove unnecessary definitions of 'null-device' - Turnbull.
-- Actually implement the specified semantics for 'defvar' - Sperber.
-- Fix `shrink-to-fit' by calling `shrink-window-if-larger-than-buffer' - Aichner.


to 21.5.15 "celery"

Build

-- Autoconf configure updates - James, Turnbull.
-- Makefile updates - James.
-- Minor updates to make-docfile.c - Begel.
-- Wrap assert_failed with EXTERN_C for modules - James.
-- Updates to modules Makefile.common - James.
-- Include emodules.h when building modules in postgresql.c
     and ldap.c - James.
-- Updates to xemacs.mak - Aichner.
-- Add some extern "C" declarations for C++ module builds
     - James.
-- Add casts for C++ builds in mule-canna.c - James.
-- Add type casts in database.c to satisy C++ compilers.
-- Log result summary of tests when the testsuite is running
     noninteractive - Aichner.
-- Add some tests for weak-lists - Crestani, Kaltenbach.


Documentation

-- Update README.(HYPERBOLE|OO-BROWSER) - Turnbull.
-- Update etc/PACKAGES - Turnbull, Koch, Youngs.
-- Update etc/sample.Xresources - Turnbull.
-- Major update and audit of all documents relating to PUI - Youngs.
-- Mention `line-move-ignore-invisible' (display.texi "Invisible Text")
     - Kyllingstad.
-- Document that end-glyph is still displayed when invisible
     is set (extents.texi "Extent Properties") - Kyllingstad.
-- Document that only begin-glyph is highlighted (extents.texi "Extents
     and Events") - Kyllingstad.
-- Various typo and docstring fixes - Turnbull, Sperber.
-- Add missing '@end' defun in lists.texi - Shelton.
-- Document ?\x00 read syntax and range limitations on ?\000 and 
     ?\x00 read syntaxes (objects.texi "Character Type") - Turnbull.
-- Document `true-list-p' (lists.texi "List-related Predicates")
     - Turnbull.


Internals

-- KKCC updates - Crestani, Kyllingstad.
-- Define DECLARE_MODULE_API_LRECORD when not ERROR_CHECK_TYPES
     - James.
-- Updates to DSO code - James.
-- Remove unused (X)OPAQUE_MARKFUN definitions - James.
-- GCPRO updates - Sperber.
-- Mouse wheel fixes in event-msw.c - Kyllingstad.
-- Use 'HAVE_DLD_INIT' instead of 'HAVE_INIT_DLD' in sysdll.c - James.
-- Rewrite ephemeron marker code - Sperber.
-- Fix printing of symbol names in .gdbinit - Golubev.
-- Fixes to `update_frame_toolbars_geometry' - Sperber.
-- Fix missing commas in `fonts' initialiser - Golubev.
-- Add `opaque_ptr_description' - Crestani.
-- Add `allocate_big_string_chars' - Turnbull, Buchholz.


Lisp API

-- New alias `apropos-customize' -> `customize-apropos' - Aichner.
-- Remove unecessary arg from `pui-set-local-package-get-directory - Youngs.
-- New key bindings in mwheel.el - Kyllingstad.
-- Make `insert-directory' to be more like FSF version - Sperber.
-- Window configuration fixes in isearch code - Sperber.
-- Implement simple object finalisation in post-gc.el - Sperber.
-- Updates to etags.el - Turnbull.
-- Updates to cl-macs.el - Pakoulin.
-- Fix "do-nothing" bug in `derived-mode-merge-syntax-tables' - Turnbull.
-- Fixes to `restore-saved-window' - James.
-- Handle missing "EMACSPACKAGEPATH" env var in 
     `package-get-package-index-file-location' - Aichner.
-- Fix substring errors in `package-admin-find-top-directory' - Aichner.
-- Fix `byte-compile-lambda' so it only discards the docstring if it is
     not also the value of the lambda - Turnbull.
-- Don't insist in lib-src directory in `path-emacs-root-p' on WinNT - Aichner.
-- Don't include '(' in `font-lock-function-name-face' - Aichner.


to 21.5.14 "cassava"

This release has a few documentation updates thanks to Steve
Turnbull, better Makefile handling for modules on MacOSX from
Andrew Begel and Jerry James.  Also, it is now possible for the
user to specify the location of the package-index file for PUI to
use, see `package-get-package-index-file-location'.

Build

-- Autoconf tweaks for building modules on MacOSX - James.
-- GCC fixes in ellcc.c - James.
-- Module Makefile fixes - Begel, James.
-- Fix shadow warning in regex.c - James.

Documentation

-- New TeXinfo node "Searching and Matching" - Turnbull.
-- New section "Legacy Versions" in FAQ - Turnbull.
-- New FAQ question Q8.0.1 - Turnbull.
-- Update split-string specs in "Regexp Search" - Turnbull.

Internals

-- Package index file updated - Koch.
-- Add some debug checks in file-coding.c - Turnbull.

Lisp API

-- Make error message report the sym checked in
     `autoload-featurep-protect-autoloads' -- Turnbull.
-- `split-string' tweaks - Turnbull.
-- Make the location of the package-index file user customisable - Youngs.
-- Turn on package-index file PGP verification - Youngs.
-- Only use message if interactive for functions in replace.el - Josefsson.

to 21.5.13 "cauliflower"

Remember that bug that made return behave as linefeed in a TTY?  It's
gone!  Thanks go out to Jerry James and Steve Turnbull for squashing
this year old bug.  Of course, that wasn't the only bug fixed this
time around.

Here are the highlights:

Build

-- Don't look for Motif if it's already been found - Buchholz.
-- Darwin, Cygwin, BerkDB autoconf fixes - Turnbull.
-- Make DEFUNed functions be tags - Buchholz.
-- Allow compiling with Motif 1 and linking with Motif 2 - Buchholz.
-- Update regexp tests - Turnbull.
-- Don't autodetect ESD (Enlightened Sound Daemon) - Turnbull.


Documentation

-- New section in PROBLEMS auxilary programs for Windows - Turnbull.
-- FAQ updates
	Q6.4.3 New aux programs for Windows - Turnbull.
-- Document failed match preserves data - Turnbull.


Internals

-- Don't use the u_int8_t etc typedefs on FreeBSD in database.c - Pluim.
-- Better support for externally defined lrecord types - Begel.
-- Only call `xm_update_progress' if Motif is defined - Youngs.
-- Define __STDC__ for BerkeleyDB - Buchholz.
-- Fix bug where XEmacs couldn't find its .dmp file - Buchholz.
-- Move `filemodestring' from lisp.h to sysfile.h - Golubev.
-- Clean ups against the possibility of sys/stat.h defining stat - Turnbull.
-- Search/match updates - Turnbull.


Lisp API

-- Fix bug preventing installing new packages - Youngs.
-- Put exit message on separate line in `command-error' - Turnbull.
-- Temporarily turn off PGP verification of package-index - Youngs.
-- Remove keymapings for 'function-key-error' - James.
-- Fix bug that mapped RET to LFD in TTYs - James.


to 21.5.12 "carrot"

Lots of updates, fixes, and features from Ben Wing (he never stops).
Also, a lot of work has gone into cleaning up the test suite.  Thanks
to Steve Turnbull, Jerry James, Daiki Ueno because now all tests from
'make check' pass 100% (at least on GNU/Linux).

Here are the highlights:

Build

-- Updates to configure.in - Steuck, James, Skyttä, Wing.
-- Major updates to Makefile.in.in - Wing.
-- Allow for separate build and source directories - Wing. 
-- Fix some compiler warnings - Wing.
-- Major clean up of xemacs.mak and friends - Wing, Aichner. 
-- Fix some Solaris 2.7 CC compiler warnings - Persico.
-- Fix for building on Mac - Palmer.
-- Work around a problem compiling with '--use-union-type' on Intel's
     ICC compiler - Buchholz.
-- Fix problems with rel-alloc compilation - Wing.
-- Sequentialize dependencies even more in update-elc-2 - Sperber.
-- Don't fatal() in 'report_sheap_usage' when need to rerun Make -
     Wing. 
-- Various updates to the test suite - Turnbull.

Documentation

-- Updates to
	INSTALL - Turnbull, Wing.
	PROBLEMS - Turnbull, Wing.
-- Global substition of .Xresources for .Xdefaults - Turnbull.
-- Update packages in ./etc/BETA - Skyttä.
-- Doc string updates - Korytov, Turnbull, Wing.
-- TeXinfo updates - Aichner, Turnbull, Wing, Youngs.

Internals

-- Fix stale match data after failed search bug - Turnbull.
-- Reformat function definitions correctly in menubar-gtk.c and
     event-gtk.c - Turnbull.
-- Fix bug matching ASCII character classes to Mule characters -
     Ueno. 
-- Frame updates for MS Win - Alexander.
-- Add .dylib as an acceptable shared library file extension to
     support MacOS X - Begel.
-- Fix bug in database.c for Berkdb 4.1 - Turnbull.
-- Regex fixes - Turnbull, Wing.
-- Coding system updates - Wing.
-- Add clear-left-side functionality in print.c - Wing.
-- Seg fault rather than abort on Cygwin in 'assert_failed' - Wing.
-- Delete popup-data object - Wing.  
-- Delete menubar_data field from frames - Wing.
-- Clean up handling of lwlib callback data GCPRO'ing - Wing.
-- Use ALLOCA() in regex.c to avoid excessive stack allocation -
     Wing. 
-- Fix subtle problem with REL_ALLOC() - Wing.
-- Change *run_hook*_trapping_problems to take a warning class, not a
     string - Wing.
-- Mule-ize encrypt/decrypt-string code - Wing.
-- Delete all support for bit-rotten CANNOT_DUMP - Wing.
-- Fix crash due to attempt to free objects across dump/undump -
     Wing. 
-- Don't get in an infinite loop running post-redisplay actions -
     Wing. 
-- Make gc_currently_forbidden static - Wing.
-- Defer redrawing if already in redisplay - Wing.
-- Add debug code for locking a dynarr to catch invalid mods - Wing.
-- Ensure that various glyph functions that eval within redisplay
     protect the evals - Wing.
-- Defer specifier-changed updating till after redisplay - Wing.
-- Require that every place inside of redisplay catch errors itself -
     Wing. 
-- Introduce separate means of holding frame-size changes - Wing.
-- Introduce "post-redisplay" methods for deferring things till after
     redisplay - Wing.
-- Disable all quit checking in redisplay - Wing.
-- Use _wexecve() when under Windows NT for Unicode correctness -
     Wing.
-- Update list of possibly valid console types - Wing.
-- Turn on Vstack_trace_on_error 'Frun_emacs_from_temacs' so that
     errors are debuggable even when occurring extremely early in
     reinitialization - Wing.
-- Define new function `emacs-run-status' - Wing.
-- Fix crash caused by an edge condition in the syntax-cache macros -
     Wing. 
-- Eliminate HAVE_WIN32_CODING_SYSTEMS, use WIN32_ANY instead - Wing.
-- Don't check_quit() unless we're unbinding a real Lisp
     `unwind-protect' - Wing.
-- Make absolutely sure there is no quit checking while we are in a
     "critical section" during frame deletion - Wing.

Lisp API

-- Fix infloop in font-lock for java files - Choi.
-- Fix split-string - Turnbull.
-- Support '(filename)nodename' as argument to 'info' - Steib.
-- Major clean up of the PUI code - Youngs.
-- Use 'equal' instead of '=' in 'saved-window-equal' - James.
-- Updates to wid-edit.el - Turnbull.
-- Better layout for Tools -> Packages -> Download Site menu -
     Aichner. 
-- More sites added to packages download sites menu - Aichner.
-- Byte-compiler warning clean up and lots of synching with FSF 21.2
     code - Wing.
-- Move lots of high-level code for computing paths into
   setup-paths.el from various places - Wing.
-- Mule and coding system updates - Wing, Turnbull.


to 21.5.11 "cabbage"

Lots of improvements and fixes this time around.  One of our key
players, Ben Wing, has drastically improved font-locking (go turn on
lazy-lock to check it out).  Apart from many other bug fixes, Ben
has also given us a speed up to the build process (--quick-build
configure option).

Other stars we should mention are:  Mike Sperber, for window
configuration fixes and updates; Stephen Turnbull for build fixes,
documentation and typo fixes.  Stephen also gave us some major updates
to autoload.el and wid-edit.el.  And also Jerry James with some more
DSO updates.

Here are the highlights:

Build

-- Updates to test suite - Turnbull.
-- Use -no-autoloads with update-elc-2 - Wing.
-- Check for strupr and strlwr - Sperber.
-- Delete auto-autoloads.el* & cutom-load.el* files on make clean - Turnbull.
-- Fix --srcdir processing - Turnbull.
-- Define DLSYM_NEEDS_UNDERSCORE on Darwin - Turnbull.
-- Use opsys=aix4-2 for AIX 5 and above - Buchholz.
-- Make ellcc search XEmacs directories for include files 1st - James. 
-- Set stack-trace-on-error, load-always-display-messages - Wing.
-- Overhaul update-elc.el, cus-dep, autoload (speed ups) - Wing.
-- Various compiler warning fixes - Wing.
-- FreeBSD updates in modules/Makefile.common - Pluim.
-- Warning fix in eldap.c - James.
-- Support C++ & KKCC compilation in Windows - Wing.
-- Various fixups in nt/config.in.samp - Wing.
-- Fixes in xemacs.mak - Wing.
-- Clean up compile errors with C++ under Windows - Wing.
-- Re-order sections in ldflags for gcc 3.2 - Okhapkin.
-- Restore USE_XFONTSET - Turnbull.
-- New symbol: DLSYM_NEEDS_UNDERSCORE - Turnbull.
-- Guard against multiple definitions of _ALL_SOURCE - Buchholz.
-- QUICK_BUILD updates - Wing.

Documentation

-- Major update to configure.usage - Wing.
-- New developer bio's - James, Skyttä, Golubev.
-- Amendments/additions to PROBLEMS:
	- PostgreSQL DSO with --error-checking=all - James.
	- Consolidate Motif problems into one section - Turnbull.
-- Amendments/additions to INSTALL:
	- Recommend Mule - Turnbull.
	- Deprecate stripped binaries - Turnbull.
-- General tidy up of etc/BETA, rewrite sections dealing with packages
   and building from scratch - Youngs.
-- General doc fixes, typos etc - Youngs, Turnbull, Palmer, Wing.
-- Fix xref in Auto-Saving - Aichner.
-- Update Local.rules File section in packages.texi - Youngs.
-- Clarify package hierarchy structure - Turnbull.
-- Major fixup of internals.texi - Wing.
-- Lots of Mule rewriting in lispref/mule.texi - Wing.
-- Document USE_UNION_TYPE evilness - Wing.
-- Document event-matches-key-specifier-p better - Wing.
-- Change illegal (for C) '//' comments to '/* */' - Shelton, Turnbull.

Internals

-- Synch rcs2log to GNU upstream - Youngs.
-- Use symbolic name `XtExposeCompressMaximal' instead of `TRUE' in
   xlwMenuClassRec - Buchholz.
-- In xm_update_progress, don't define unless LWLIB_WIDGETS_MOTIF - Buchholz. 
-- Rename class -> class_ & new -> new_ - Wing.
-- KKCC update in postgresql.c - Wing.
-- KKCC update in eldap.c - James.
-- Fix for unix_create_process - Ueno.
-- Set stack reserve size during unexec() - Piper.
-- Use 'struct htentry' not 'struct hentry' in elhash.c - Wing.
-- New macros ALIST_LOOP_3, ALIST_LOOP_4.
-- Fix 'xemacs -batch -l dunnet' under Cygwin - Wing.
-- Implement delaying of XFlush() if pending expose events - Wing.
-- Fix some longstanding bugs in X quit handling - Wing.
-- Correct the message output upon crashing to be more up-to-date - Wing.
-- Add dp() & db() as short synonyms of debug_print() &
   debug_backtrace() - Wing.
-- Add C++ error-checking code to verify problems with GCPRO/UNGCPRO - Wing.
-- Change the way gap arrays are allocated (for KKCC) - Wing.
-- Now lcrecords set the type of items sitting on the free list to
   lcrecord_type_free - Wing.
-- All lcrecord allocation functions now zero out the returned
   lcrecords - Wing.
-- Additional asserts in FREE_FIXED_TYPE - Wing.
-- Make bit vectors lcrecords, like vectors - Wing.
-- MARKED_SLOT() call no longer includes semicolon - Wing.
-- Factor out some code duplicated in KKCC and pdump - Wing.
-- KKCC updates - Wing.
-- Add a fifth field "flags" to memory_description - Wing.
-- Add support for "description maps" - Wing.
-- Redo XD_UNION so it works inline and change format to provide info
   for pdump - Wing.
-- Textual changes: 
	- lrecord_description -> memory_description - Wing.
	- struct_description -> sized_memory_description - Wing.
-- Initialize protect_me field of popup_data in set_frame_menubar - Sperber
-- GTK updates - Sperber.
-- Don't lead to a crash if dealing with a dead
   window/frame/device/console - Sperber.
-- Prevent crash for combination windows - Sperber.
-- Window fixes in Fdelete_window - Sperber.
-- Module updates in emodules.h - James.
-- Fprovide from 'vars_of_file_coding' not 'syms_of_file_coding' - Turnbull.
-- Fix syntax of macro in 'mark_object_maybe_checking_free - Turnbull.
-- Eliminate bogus require-prints-loading-message - Wing.
-- Turn on `load-warn-when-source-newer' by default - Wing.
-- Fix up crashes when selecting menubar items due to lack of GCPROing
   - Wing.
-- Implement tail-recursion in KKCC - Wing.
-- Fix UTF-(8|16) detector - Wing.
-- Fix problems with reentrant calling of lwlib and associated crashes
   when selecting menu items - Wing.
-- Improve redisplay handling of preemption - Wing.
-- Return the parameter from strlvr, strupr, depend on !HAVE_STRUPR - James.
-- In sysdll.c included lisp.h to define needed alloca_array - Begel.
-- Pull GC_CHECK_NOT_FREE out of USE_KKCC - Sperber.
-- Abort when any attempts to output a stream console are made - Wing.
-- Formatting fixes in redisplay-output.c - Wing.
-- Clean up redisplay a bit - Wing.
-- Fix scrollbar code TTY devices don't have them - Sperber.
-- Major reworking of profile code - Wing.
-- Dramatically improve redisplay speed over slow X connections - Buchholz.
-- Move syntax table description from buffer.c to syntax.c - Wing.
-- Updates to char,mirror,syntax tables code - Wing.
-- Niggly whitespace fixups - Wing.

Lisp API

-- Updates to (japan|cryil)-util.el - Turnbull.
-- Updates to how XEmacs computes various paths - Sperber.
-- Window configuration fixes - Sperber, Wing.
-- Make Info-insert-dir end n separator - Buchholz.
-- Drastically reorganise autoload.el - Turnbull.
-- Omit M-S-home/end from motion keys - Wing.
-- Synch wid-edit to GNU/Emacs 21.3.50 - Turnbull.
-- Updates to hyper-apropos - Wing.
-- Reorganise Help -> Info submenu - Wing.
-- Fix bug when end > start in text-props - Wing.
-- Fix walk-windows - Wing.
-- Fix for call to set-language-unicode-precedence-list - Nyyss~nen.
-- Synch up byte-optimize.el - Wing.
-- Include FUNLIST argument to generate-c-file-autoloads-1 - Wing.


to 21.5.10 "burdock"

Please accept my apologies for the very long wait between releases
this time around.  My PC chose the 21.5.10 development cycle to go up
in a sickening cloud of smoke. :-( (Steve Youngs <youngs@xemacs.org>)

Lots of updates from Ben Wing (as always), also from Andy Piper, Mike
Sperber, and Stephen Turnbull with lots of documentation updates and
fixes.  One new exciting addition in this release is that the LDAP and
PostgreSQL code has been extracted out of the core C code and moved to
DSO's.  We have Jerry James to thank/blame/worship for that.

Build

-- Reset sheap-adjustment to zero - Piper.
-- Make --pdump default to yes on Linux - Turnbull.
-- Only use -Wpacked in GCC v3 - Wing.
-- Remove LISP_FLOAT_TYPE definition. - James.
-- Temporarily disable DSO's under Cygwin - Wing.
-- Updates to DSO building code (Makefile.in, configure.in etc) - Wing, James.
-- Separate compiler warning flags from CFLAGS - Wing.
-- Delete auto-autoloads.e* & custom-load.e* on 'make clean' - Turnbull.
-- Disable detection of 'getaddrinfo' for HP-UX 11.XX - Turnbull.
-- Include modules directories in 'make tags' - Youngs.
-- Fix shadowing warnings in make-docfile.c - Wing.
-- Move the common stuff from postgresql/ldap Makefile.in.in &
     configure.ac's into a "common" Makefile and configure script -
     Wing.
-- Major cleanup of ellcc - Wing, James.
-- Add Makefile var to pick up '--site-libraries' in DSO's - Youngs.
-- Avoid unnecessary deviations from UNIX 'describe-installation' in
     xemacs.mak - Aichner.
-- Don't confirm overwriting files in xemacs.mak - Aichner.
-- Support 'xemacs_extra_name' in xemacs.mak - Aichner.
-- Some gcc/g++ 3 fixes - Wing.
-- Warning fixes - Wing.
-- Fix some C++ errors - Wing.
-- Allow for C needing volatile and C++ that can't have volatile,
     remove previous volatile hacks - Wing.
-- Try for a working Cygwin build with old unexec - Wing.
-- Warning suppression - Turnbull.
-- New Mule character class regexp tests - Turnbull, Ueno.
-- Better handling of known bugs in tests - Turnbull.
-- Add test for stale subexpr match-data - Turnbull.
-- Update syntax-table tests - Turnbull.
-- Add word-boundary regexp tests - Turnbull.

Documentation

-- Updates to PROBLEMS file
	Running/Linux - Lesstif 0.93.36 - Turnbull
	Running/IRIX - Irix 6.5 coredumps - Turnbull
	Running/Cygwin - "No cygXpm-noX" fatal error - Turnbull
	Missing charsets - Remove ambiguity - Turnbull
	Running, General - FontSet warnings - Turnbull
	MacOS/X - Stack limitation - Turnbull
	Digital Unix - Generalise - Turnbull
	AIX - USE_KKCC lossage - Turnbull.
-- Update instructions in info/dir - Wallington.
-- Recommend TeXinfo 4.2 in INSTALL - Turnbull.
-- Add example in sample.Xdefaults - Boffi.
-- Typo fixes - Yamaoka, Youngs, Turnbull, Wing.
-- Docstring fixes - Turnbull, Piper, Skyttä, Wing.
-- Update description of XEmacs Patches and Design ML's - Turnbull.
-- Incorportate ChangeLog.X into ChangeLog - Wing.
-- FAQ additions/amendments:
	Debugging FAQ improvements - Wing.
	Mention union type bugs - Turnbull.
	Debugging HOWTO improvements - Turnbull.
	Decoding Lisp objects in the debugger - Turnbull.
	Fix location of FAQ on website - Skyttä.
	Add missing menu entry for Q3.2.7 - Verna.
	Displaying non-ASCII - Turnbull.
	Mention bug report commands - Turnbull.
	Revise Q1.3.[1-6] - Turnbull.
	New FAQ for "no cygXpm-noX" fatal error - Turnbull.
-- New TeXinfo nodes: 
	"Widget Internals" - Turnbull.
	"Simple Specifier Usage" - Turnbull.
	"Compilation Options" - Turnbull.
-- Document charset Unification and Tables - Turnbull.
-- Better short description of Mule in Mule submenu - Turnbull.
-- Regression Testing XEmacs design hints & rewrite - Turnbull.
-- Document 'face-frob-from-locale-first' - Golubev.
-- Document 'set-face-background-pixmap-file' - Verna.
-- Add urefs to Doug Lea's * Wolfram Gloger's home pages in "Low-Level
     Modules" - Turnbull.
-- Update "Available Packages" - Skyttä.
-- Document 'append' arg of 'add-to-list' - Skyttä.
-- Add optimisation hints in "Techniques for XEmacs Developers" - Turnbull.

Internals

-- Add *menubar*FontSet and *popup*FontSet entries - Turnbull, Skyttä.
-- Extract ldap and postgresql code from core and put them into DSO's - James.
-- 'Fset_window_point' Correct to GNU/Emacs behaviour (fixes some bugs
     in Gnus) - Wing.
-- Inhibit GC in critical sections - Wing.
-- Fix calculation in 'report_sheap_usage' - Piper.
-- Implement and use new var 'garbage_collection_messages' - Wallington.
-- Fix 'open_database' for Berkeley DB 4.1.x - Allen.
-- Updates to frame code - Sperber.
-- Change C debugger entrance: error message, then stack trace, then
     exiting message, then force debugger - Wing.
-- Use EQ not EQUAL in 'mswindows_init_frame_1' - Wing.
-- Better redisplay-related asserts - Wing.
-- Don't generate large warning strings when they'll be discarded - Wing.
-- Implement 'debug-on-error' as documented - Wing.
-- Fix docs relating to QUIT which can't GC under any circumstances - Wing.
-- More robust package compilation and debugging - Wing.
-- Overhaul profile code - Wing.
-- Fix crashes due to incorrectly ported GNU/Emacs code - Wing.
-- Clean up realpath.c - Wing.
-- DdeCreateStringHandle needs to be manual due to new Cygwin bug - Wing.
-- Fix some Cygwin complaints - Wing.
-- Unconditionally use LISP_FLOAT_TYPE code - James.
-- Improve crash message in 'shut_down_emacs' - Turnbull.
-- Update NAS code for NAS 1.6 and later - Toy.
-- Fix "unused variable" warnings in mule-canna.c - Turnbull.
-- Prototype 'enqueue_focus_event' - Turnbull.
-- Use BORDER_FIDDLE_FACTOR instead of 10 in 'layout_layout' - Piper.
-- Add optional 'noerror' arg to 'Frequire' - Wallington.
-- Only resize 'layout_query_geometry' dynamically if static sizes
     haven't been set - Piper.
-- Fix infloop upon a gdm logout - Sigelman.
-- Fix scope of 'num_nonshy_regs' - Turnbull.
-- Fix "stale match data" bug - Turnbull.
-- Don't call 'XtDisplay' on a destroyed widget - Golubev.
-- Update specifier code - Sperber.
-- Update process code - Sperber.
-- Move ldap/postgresql code out to DSO's - James.
-- Normalise Ffile_truename and drive spec on cygwing to win32 format
     - Piper.
-- Use 'closesocket' instead of 'CloseHandle' in 'winsock_closer' - Alexander.
-- Coding system updates - Ikiuo.

Lisp API

-- Update window-xemacs.el to fix 'goto-line' - Wing.
-- Add garbage collection messages - Wallington.
-- Re-implement window configurations in Emacs Lisp - Sperber.
-- Enhance background-pixmap-file code - Verna.
-- New macro 'save-window-excursion' to eventually replace bytecode
     instruction - Sperber.
-- Move window.el et al up the order in dumped-lisp.el - Sperber.
-- Don't use 'save-window-excursion' in
     'shrink-window-if-larger-than-buffer' - Sperber.
-- Updates to pixel-size code in dialog.el - Sperber.
-- Remove nonworking 'breakpoint-on-error' - Wing.
-- Extract out 'with-displaying-help-buffer' into a more general mechanism
     - Wing.
-- Don't catch errors when noninteractive in startup.el - Wing.
-- Fix warnings in code-files.el, loadhist.el, & package-get.el - Wing.
-- Simplify code in '*-reset-device-font-menus' - James.
-- Synch font-menu.el to the 21.4 version - Turnbull.
-- Preserve return value from 'call-process' - Sperber.
-- New functions in replace.el that operate on regions - Evans.
-- Run 'delete-frame-hook' in general dialogs only - Piper.
-- Add a margin parameter in autoload.el for DSO autoloads - James.
-- Conditionalise autoloads for DSO's on the existence of the DSO - James.
-- Always set module directories/paths in dump-paths.el - James.
-- Bring list of package sites up to date - Skyttä.
-- Add "Find Variable" menu entry for 'hyper-apropos-find-variable' -
     Wallington
-- Fix 'view-lossage' interactive spec - Wallington.
-- Synch 'with-output-to-string' with GNU/Emacs 21 - Wallington.
-- Bind C-xrd to 'delete-rectangle' - Yamaoka.
-- Move entries in 'auto-mode-alist' out to packages for the modes
     that are in packages - Skyttä
-- New compatible alias for 'lookup-syntax-properties'
     ('parse-sexp-lookup-properties') - Turnbull.
-- Enable C autoloads for DSO's - James.
-- Update revert-buffer code - Piper.
-- Add new coding system 'utf-8-bom' - Ikiuo.


to 21.5.9 "brussels sprouts"

The main thrust of this release is the new GC algorithms.  If you want
to test this out configure with '--use-kkcc'.

There are of course, the usual swag of bug fixes, typo fixes, and
document updates.

-- Add an extra element to the version string that can be used to
   include a date in the version string - Youngs.
-- Improve help string for --with-widgets configure option - Skyttä.
-- Define runtime & build problems, and rewrite "Hannibal Lecter"
   stuff in PROBLEMS - Turnbull.
-- Add builtin and constant faces to font-lock-face-list - Skyttä.
-- Japanese language fixes - Yamaoka.
-- Fix find-library to allow Mule XEmacsen to find compressed
   libraries - Youngs.
-- New alias for 'delete-indentation' (join-line) - Wallington.
-- Support docstring for define-derived-mode - Turnbull
-- Doc fix for keybindings in term.texi and misc.texi - Skyttä.
-- Bring package list up to date in packages.texi - Skyttä.
-- Document purecopy as a no-op - Josefsson.
-- New document chapter "Regression Testing XEmacs" - Turnbull.
-- Add "USE_KKCC" option to ./nt/xemacs.mak - Aichner.
-- New GC algorithms implemented (Turn them on with --use-kkcc
   configure option) - Sperber, Crestani, Kaltenbach, Bush.
-- Define HAVE_WCHAR_H for native Win32 builds - Harris.
-- Fix x_locate_pixmap_file make sure path is not 0 - MacLennan.
-- Fix memory leak - Verna.
-- Add missing call to 'xfree (newname)' in 'make_coding_system_1
   - Verna. 
-- Fix --with-mule --with-gtk builds - Barta.
-- Make SEPCHAR a required arg to Fsplit_string_by_char - Palmer.
-- Make locate_file indicate success with nonnegative return if MODE
   is nonnegative - James.
-- Fix splitting window horizontally not splitting evenly - James.
-- ORDINARY_LINK OK for Linux - James.
-- Don't bogusly reinitialise ascii_character property in
   maybe_define_x_key_as_self_inserting_character - Astapov.
-- Add warning to SOE_DEBUG about not using until debugging functions
   are rewritten - Turnbull.
-- Update 'do_autoload' to GCPRO both arguments - Turnbull.
-- Update automated tests so they don't barf if required packages
   aren't present - Turnbull.
-- Organise NSIG setting code for SVR4 in a better way - James.
-- Various typo fixes - Skyttä, Turnbull, James.


to 21.5.8 "broccoli"

Lots of fixes and changes.  This release is primarily been done to
make way for the new GC stuff from Mike Sperber.

CHANGES now uses surnames as listed in the ChangeLogs to identify
contributors.  And I haven't sorted the changes into different
categories.  Maybe next release...

-- New configure option "--use-kkcc" for the upcoming new GC
   algorithms - Sperber.
-- Identify "--with-modules" as an autodetected configure option -
   James. 
-- Add a couple of configuration questions to PROBLEMS - Turnbull.
-- Test for wchar.h in configure - Sperber.
-- Update package-index files - Youngs.
-- s/Xemacs/XEmacs/ doc fixes - Aichner.
-- Sync make-docfile.c with GNU - James.
-- Updates to gutter-items - Palmieri.
-- Sync setenv with GNU - Wallington.
-- Remove package-get's dependence on APEL - Youngs.
-- Fix case fold bug in replace-in-string - Verna.
-- Updates to code-process.el and process.el - Alexander.
-- Updates to mule/kinsoku.el - Yamaoka.
-- Updates to define-derived-mode - Wallington.
-- Printer fixes - Piper.
-- Updates to window-xemacs.el & frame.el - James.
-- Doc fix gutter-items.el - Piper.
-- Sync ":set-after" in custom with GNU - Piper.
-- Sort the lists in enabled-behavior-list - Galibert
-- Updates to lwlib-Xm.c - Piper.
-- Various doc fixes to the TeXinfo docs - Aichner.
-- GC fixes - Sperber.
-- Updates to lisp.h, symbols.c for DSO's - James.
-- Fix to mswindows_need_event - Alexander.
-- Declare Fcdr_safe to be callable from C - Turnbull.
-- Ffunctionp return nil for autoloaded macros & keymaps - Niksic.
-- Subwindow fixes - Ueno.
-- Include wchar.h only if available, define wclsen if not - Sperber.
-- Fixes to Fstart_process_internal - Sperber.
-- Fixes to init_ralloc for pdump - Sperber.
-- Remove duplicated definition of Lisp_Devmode - Bush.
-- Fixes to toolbar/redisplay - Piper.
-- Windows DDE fixes - Moore.
-- Fixes to 'query_string_geometry' and 'widget_logical_unit_height' -
   Piper.
-- Fix problem with XEmacs freezing with certain virtual window
   managers on Windows - Rankin.
-- Conditionalise calls to syms_of_dired_mswindows &
   vars_of_dired_mswindows on WIN32_NATIVE instead of HAVE_MSW_C_DIRED
   - Harris.
-- Process related fixes - Sperber.
-- Fix #includes in input-method-motif.c - Galibert.
-- Fixes to automated tests - Sperber.


to 21.5.7 "broccoflower"

CHANGES now uses @xemacs.org alias to identify contributors.  If the
contributor doesn't have one (that I know about), the full name from
the ChangeLog is used.

UI changes and runtime bugs

-- Add: ask "yes/no/diff" question when recovering; known problem: dialog
   is modal, so you can't scroll the diff -- ben
-- Add: balloon help for package-ui -- youngs
-- Add: global-abbrev-mode, defining-abbrev-turns-on-abbrev-mode -- ben
-- Add: lots of new menubar items -- ben
-- Add: new winclient for MS Windows -- acs
-- Add: option kill-word-into-kill-ring controls whether words are "cut"
   into the kill ring, or "cleared" into nothingness -- ben
-- Add: revert-buffer optimization for unchanged files -- andy
-- Add: undo-all-changes back to the beginning -- ben
-- Fix:	M-C-backslash does indent-region-or-balanced-expression, S-Tab
   inserts a TAB char -- ben
-- Fix: Cmds menu so that most used commands appear directly on the menu and
   less used commands appear in submenus -- ben
-- Fix: NILP(lim) crash in search.c -- mike
-- Fix: STACK_TRACE_EYE_CATCHER now visible in MS Windows traces -- jonathan
-- Fix: XmProcessTraversal crash -- stephen
-- Fix: avoid infinite loop in extent code -- ben
-- Fix: crash due to errant xfree() -- ben
-- Fix: crash in gtk_popup_menu -- wmperry
-- Fix: crashes due to excessive alloca -- ben
-- Fix: detection of metric units on MS Windows -- jonathan
-- Fix: don't output bell as ^G in console-stream when not a TTY -- ben
-- Fix: improve MS Windows printer support -- andy
-- Fix: improve appearance for gutters and dialogs -- andy
-- Fix: improve lisp-mode indentation handling -- ben
-- Fix: interprogram cut functions now don't add selection twice -- stephen
-- Fix: many netinstaller improvements -- andy
-- Fix: popup dialogs on MS Windows -- andy
-- Fix: recover-session only shows session files with recoverable files,
   and in chronological order -- ben
-- Fix: save customized values MUCH faster and in alphabetic order,
   custom-save-pretty-print turns on/off pretty-printing values
   -- Nickolay Pakoulin
-- Fix: semicolons inside strings are not comments in lisp-mode -- ben
-- Fix: short filename handling on Windows -- Peter Arius
-- Fix: some crashes in syntax code -- ben
-- Fix: some crashes with multibyte text -- ben
-- Fix: two frames displaying the buffer, in different places; in one,
   temporarily switch away to another buffer and then back, and your position
   has been reset to the other one in the other frame -- ben
-- Fix: update installed.db after updating packages -- andy

Documentation

-- Add: New FAQs -- stephen, adrian
-- Add: New or improved code and documentation in sample.init.el -- ben,
   stephen
-- Add: PROBLEMS: Hannibal Lecter crash, EFS AUTH failure, mail locking
   -- stephen
-- Add: etc/TUTORIAL.se -- Mats Lidell
-- Add: new Internals manual nodes -- ben, stephen, darrylo
-- Add: why modules don't use RTLD_GLOBAL -- james
-- Fix: README.integral-types doc moved to Internals, code moved to
   README.global-renaming -- ben
-- Fix: README.packages: info about --package-path -- ben
-- Fix: improve docstrings and comments -- ben, stephen, adrian,
   John H. Palmieri
-- Fix: typos, minor updates -- stephen, I. N. Golubev, Frank Schmitt,
   adrian, youngs
-- Fix: update etc/BETA -- Jarl Friis
-- Fix: update etc/package-index.LATEST.pgp -- youngs
-- Fix: update photos -- hniksic

Lisp API

-- Add: functions: args-out-of-range, argument-in-range-p,
   check-argument-range, indent-balanced-expression-function,
   indent-balanced-expression, indent-region-or-balanced-expression,
   image-instance-instantiator, truncate-string-with-continuation-dots,
   get-user-response, unicode-precedence-list -- ben, stephen
-- Fix: GNU synchs of frame-parameter, makehash, buffer-local-value,
   line-beginning-position, line-end-position, with-temp-message,
   bound-and-true-p, propertize, delete-and-extract-region, add-to-list,
   string-to-char-list, find-non-ascii-charset-region,
   find-non-ascii-charset-string, truncate-string-to-width, plist-to-alist,
   kill-ring-max, kill-new -- John Paul Wallington, youngs, ben, james, ville
-- Add: set-frame-pixel-width, set-frame-pixel-size -- andy
-- Add: args to map-specifier, various "heuristic" specifier functions -- ben
-- Fix: call-process moves to Lisp -- ben
   -- allows a buffer to be specified for input and stderr output
   -- use it on all systems
   -- implement C-g as documented
   -- clean up and comment
   -- call-process-region uses new call-process facilities; no temp file.
   -- remove duplicate funs
-- Add: compat.el, preliminary (not working) code -- ben
-- Add: handle subprocess stderr separately (src/ChangeLog 2002-05-28) -- ben
-- Add: new error trapping mechanism (src/ChangeLog 2002-05-28) -- ben
-- Add: pixel-based sizing APIs: set-frame-pixel-height,
-- Add: preliminary support for ELL autoloads -- james
-- Add: toolbar face -- wmperry
-- Add: widget "logical-unit" sizing APIs: widget-logical-to-character-width,
   widget-logical-to-character-height -- andy
-- Fix:	paths-find-architecture-directory searches in
   `system-configuration'/`base', not `base'`system-configuration' -- james
-- Fix: default CRLF conversion of process output off -- ben
-- Fix: default value of gethash to Qunbound -- ben
-- Fix: face-handling code (superseded by ben's overhaul) -- jan, andy
-- Fix: layout improvements -- andy
-- Fix: major overhaul of face-handling code -- ben
  -- avoid truenaming fonts
  -- msw-faces.el APIs now accept names and font instances, return names
  -- rewrite frobbing functions in faces.el
  -- don't duplicatively set a global specification for the default font
  -- remove redundant face lists from x-faces.el and msw-faces.el
  -- call init-global-faces under MS Windows!
  -- correct weight names in font.el.

Internals

-- Add: new APIs -- ben
   -- macros to GCPRO arrays
   -- default argument for char tables
   -- signal extent changes
   -- internal_bind_*, check_specbind_stack_sanity
   -- partial support for 8-, 16-, and 32-bit fixed-width text
   -- new cons treatment (src/ChangeLog 2002-05-28)
   -- rename character types to Itext, Ibyte, Ichar (src/ChangeLog 2002-06-05)
   -- rename various identifiers for consistency
-- Add: New GC preparation -- mike, Martin Köbele, Jens Müller
-- Add: support for fastcall in MS Windows -- ben
-- Fix: ELL APIs -- james
   -- load only once
   -- no longer use RTLD_GLOBAL
-- Fix: ELLs now use RTLD_NOW instead of RTLD_LAZY -- Andrew Begel
-- Fix: Many Mule changes -- ben
-- Fix: call-process ensures that the argument to `symbol-value-in-buffer'
   is a buffer even if `buffer' is a string -- mike
-- Fix: code that outputs into a buffer, use unwind protects, etc. -- ben
-- Fix: complete implementation of some Unicode functions, S-caron test
   failure -- stephen
-- Fix: conditionalize code depending on features like toolbar -- jonathan,
   Mike Alexander
-- Fix: create new process-synchronize-point to avoid dynamic binding
   problems; fix bogosity in setting process sentinels -- ben, mike
-- Fix: make a lot of code use common includes and implementations
   (see 2002-06-20 src/ChangeLog) -- ben
-- Fix: move global-map to keydefs.el -- ben
-- Fix: new signal/C-g handling (src/ChangeLog 2002-05-28) -- ben
-- Fix: numerous problems with the case-table implementation -- ben
-- Fix: quoting of native-coding-system in CJK files -- Daiki Ueno
-- Fix: race condition in process handling -- Nix
-- Fix: recover gracefully from internal XOpenDevice failure -- mike
-- Fix: redo syntax cache code -- ben
-- Fix: save-restriction now uses markers -- ben
-- Fix: small bugs -- stephen, ben, andy, martin, Eric Gillespie Jr

Build

-- Add: basic support for handling ISO 2022 doc strings in make-docfile -- ben
-- Add: tmpdir for install, allowing simultaneous run & build -- andy
-- Fix: "Stop Build" in VC++ now works -- Ben
-- Fix: #undef INTERNET_DOMAIN_SOCKETS build of gnuserv -- Greg Steuck
-- Fix: --with-widgets autodetection -- jan
-- Fix: 64-bit support -- Andreas Jaeger, Gregory Steuck
-- Fix: MS Windows Makefile cleanups -- ben, jonathan
-- Fix: MS Windows builds default to pdump -- ben
-- Fix: assorted build breakage -- ben, mike, andy, Malcolm Purvis
-- Fix: check for EOF in make-docfile -- ben
-- Fix: config.h.in organization -- ben
-- Fix: ensure combined X and windows build gets widgets -- andy
-- Fix: implement configure option moduledir -- Mike Fabian
-- Fix: spurious failures in tests -- ben, stephen
-- Fix: test harness now outputs FAIL messages to stderr in batch mode -- ben
-- Fix: test-harness.el now cleans up Check-Message and Check-Error-Message
   when done -- stephen
-- Fix: typos and platform specific bugs in configure -- Malcolm Purvis,
   galibert, Paul Stodghill
-- Fix: warnings -- ben, wmperry, stephen, didier

to 21.5.6 "bok choi"

UI changes and runtime bugs

-- Fix: process waiting on MS Windows -- Mike Alexander
-- Fix: (maybe) GTK progress bar crashes at startup -- William M. Perry
-- Fix: detect printer set up for metric units -- Jonathan Harris
-- Fix: add_charsets_to_precedence_list -- IKEYAMA Tomonori
-- Change: misc menubar -- John Paul Wallington
-- Add: auto-mode-alist: GNUmakefile is a Makefile, "system default"
   Xdefaults and friends get xrdb-mode -- Ville Skyttä
-- From  Ben Wing  <ben@xemacs.org>.
  -- Fix: init_process_io_handles obeys coding-system-for-{read,write}.
  -- Fix: bug in md5 handling.
  -- Fix: data corruption in print.c from print_depth becoming negative.
  -- Fix: "nil channel" in MS Windows magic events crashes.
  -- Fix: (tentative) redisplay crash freeing display line structures.
  -- Fix: (tentative) TTYs don't work.
  -- Fix: too-small SHEAP_ADJUSTMENT on Cygwin (can't run temacs).
  -- Fix: hscroll/truncation/continuation glyphs causing "jumping lines".
  -- Fix: problem with text files with no newlines ().
  -- Fix: errors when opening (e.g.) mule-ucs/lisp/reldata/uiso8859-6.el.
  -- Fix: (partial) excess memory use in Unicode processing, esp. at startup
  -- Fix: sample.init.el (grep-all-files-in-current-directory-and-below):
     Missing argument.
  -- Fix: smoother scrolling on MS Windows.
  -- Change: Move the menubar frame commands from the View menu to
     the File menu, to be consistent with how most other programs do
     things.  Move less-used revert/recover items to a submenu.  Make
     "recover" not prompt for a file, but recover the current buffer.
  -- Change: implementation of matching font to charset.
  -- Change: default MS Windows font to Lucida Console, increase
     default frame size on Windows to 50 lines.
  -- Add: runtime flag -no-packages inhibits adding package lisp to load-path.
  -- Add: much functionality to behavior.el.
  -- Add: more Unicode translation files.

Documentation

-- Add: define STACK_TRACE_EYE_CATCHER for Windows -- Jonathan Harris
-- Texinfo (internals): Add xref in emodules.texi -- Stephen J. Turnbull
-- Texinfo (lispref): Unicode Support, Behaviors -- Stephen J. Turnbull
-- Texinfo (user): Behaviors -- Stephen J. Turnbull
-- Improve auto-mode-alist -- Simon Josefsson
-- Docstrings: completion-ignored-extensions, file-name-all-completions --
   John H. Palmieri
-- From  Ben Wing  <ben@xemacs.org>.
  -- New ChangeLog for ./etc/.
  -- Updated: NEWS.
  -- Improve docs (developers): tree layout, merging branch to trunk.
  -- Improve docs (lispref): CL loop, menu sorting, sound-default-alist
  -- Obsoleted Lisp: 'sref, char-bytes.
  -- Internals: Revamped the sound documentation.
-- Typo fixes -- Adrian Aichner

Lisp API

-- From  Ben Wing  <ben@xemacs.org>.
  -- Fixed: bug in keymap iteration in cl-macs.el.
  -- Fix: bugs in language environments English and Ethiopic
  -- Change: lisp/mule/*.el -- convert to XEmacs style.
  -- Add (synch to GNU): get-window-with-predicate, ALL-FRAMES,
     some-window, count-windows, window-safely-shrinkable-p,
     count-screen-lines, shrink-window-if-larger-than-buffer
  -- Add (line-oriented mouse selection):  New functions
     mouse-consolidated-yank mouse-yank, mouse-track,
     default-mouse-track-normalize-point,
     default-mouse-track-return-dragged-selection, mouse-track-by-lines,
     mouse-track-insert mouse-track-adjust-by-lines, mouse-track-insert-1,
     mouse-track-insert-by-lines, mouse-track-delete-and-insert-by-lines
  -- Add (warnings): Add a consistent way to execute code,
     catching all errors and displaying a warning, including a
     backtrace showing where the error occurred.  New functions
     backtrace-in-condition-handler-eliminating-handler, with-trapping-errors,
     view-warnings.  Integrate show-message-log with view-lossage.
  -- Add (debugging): New functions  debug-print-1, debug-print,
     debug-backtrace.
  -- Add (misc utils): map-plist, show-memory-usage, compare-strings,
     truncate-string-to-width, variable require-prints-loading-message.
  -- Add many languages and charsets.
  -- Add (autoloads): Support defun*, defmacro*.
  -- Add (byte-compiler): with-boundp, if-boundp, when-boundp,
     and-boundp, declare-boundp, globally-declare-boundp, with-fboundp,
     if-fboundp, when-fboundp, and-fboundp, declare-fboundp,
     globally-declare-fboundp, with-byte-compiler-warnings-suppressed
  -- Warning fixes.

Internals

-- Add: Get & SetLocaleInfo from winnls.h -- Jonathan Harris
-- Add: codepages latin-jisx0201, japanese-jisx0212, remove
   japanese-jisx0208-1978 -- IKEYAMA Tomonori
-- Fix: Use wrap_emacs_*(), not wrap_*() for gtk_boxed, gtk_object, ffi --
   William M. Perry
-- Fix: I18N APIs on windows -- Jonathan Harris
-- Fix: typos causing GTK build errors -- Malcolm Purvis
-- Warning fixes -- William M. Perry
-- From  Ben Wing  <ben@xemacs.org>.
  -- Change: error-checking macros: ERROR_CHECK_TYPECHECK -> ERROR_CHECK_TYPES,
     ERROR_CHECK_CHARBPOS -> ERROR_CHECK_TEXT, add ERROR_CHECK_DISPLAY,
     ERROR_CHECK_STRUCTURES.
  -- Change: Redo print_*().
  -- Change: character-to-unicode char-to-unicode; also unicode-to-char{acter}.
  -- Change: Replace XSETFOO with wrap_foo().
  -- Change: symbol->name a Lisp_Object, not Lisp_String *.  Eliminate latter.
  -- Change: rearrange init calls in emacs.c.
  -- Add: (partial) category API compatible with FSF.
  -- Add: (partial) GC triggering based on percentage of total memory
     usage.  Not currently activated.
  -- Add: (partial) sledgehammer redisplay check.
  -- Add: error-behavior ERROR_ME_DEBUG_WARN.
  -- Add: more error checking on Dynarrs.
  -- Add: assert_at_line(), for use in asserts inside of inline functions.
  -- Add: resizing_buffer_to_lisp_string().
  -- Add: function get_charset_limits.
  -- Add: (tentative, may go away) foo_checking_assert_at_line() macros.
  -- Add: new event methods for printing, comparing, and hashing magic
     events, to avoid event-type-specific stuff.
  -- Fix eifree().  Use Eistrings in various places
  -- Fix: bugs in chartab implementation and doc strings.

Build

-- Fix: make-mswin-unicode.pl -- Ben Wing, Jonathan Harris
-- Fix: .texi files for Cygwin makeinfo -- Jonathan Harris
-- Fix: Perl quoting in Windows build -- Jonathan Harris, Ben Wing
-- Fix: Generate more intermediate files in obj subdirectory -- Jonathan Harris
-- From Ben Wing  <ben@xemacs.org>.
  -- Fix: require errors in behavior.el
  -- Fix: compile error when TTY-only.
  -- Change: update check_cygwin_setup.sh for current Cygwin reality.
  -- Change: Makefile regenerates itself if out of date.
  -- Change: improve error-checking config for Windows
  -- Add: HAVE_SYS_TIMES_H config.h #define.
  -- Add: new error-checking types in configure.
  -- Add: .cvsignore

to 21.5.5 "beets"

Documentation
-- new external-widget example node -- Stephen Turnbull
-- new packaging manual nodes -- Steve Youngs, Stephen Turnbull
-- new Swedish TUTORIAL -- Mats Lidell
-- update etc/BETA -- Jarl Friis, Stephen Turnbull
-- update FAQ, new FAQs -- Adrian Aichner, Stephen Turnbull
-- fixes for build-breaking typos in Info docs -- Jeff Miller, Darryl Okahata
-- misc comment and docstring improvements -- Valdis Kletnieks
   Pretty much all the code fixers fixed docs too:  keep up the good
   work, folks!

UI
-- fix switching between virtual desktops on MS Windows -- Adrian Aichner
-- improve Customize: modifier-keys-sticky-time, abbrev-mode-line-string,
   overwrite-mode-line-string, auto-fill-mode-line-string,
   defining-kbd-macro-mode-line-string -- John Paul Wallington
-- improve GTK clipboard handling -- Eric Gillespie, Jr.
-- improve Info dir - generate file if non-existent -- Michael Sperber
-- improve printer handling -- Adrian Aichner, Björn Torkelsson
-- support GUI toolbar shadow thickness adjustment -- Bill Perry
-- support ISO 8859/15 (Euro) -- Stephen Turnbull
-- support Sieve in auto-mode-alist -- Simon Josefsson
-- suppress ask-user-about-supersession-threat if CLASH_DETECTION -- Daiki Ueno

Lisp API
-- synch from GNU Emacs 21: quit-window -- Christoph Wedler

Internals
-- improve dead console handling in post-command code -- Ben Wing
-- improve handling when XOpenDevice calls error handler -- Mike Sperber
-- move disabled-command-loop to C -- Jan Vroonhof

Build
-- improve Athena widgets detection -- Jan Vroonhof

to 21.5.4 "bamboo"
-- auto-mode support .9 files as man pages -- Michael Sperber
-- auto-mode support configure.ac as m4 -- Edward M. Lee
-- bind `replace-rectangle' to `C-x r p' -- Didier Verna
-- bind `hyper-apropos-find-variable' (new) to `v' in hyper-apropos-help-map
   -- David A. Panariti
-- bind `delete-other-frames' to `C-x 5 1' -- John Paul Wallington
-- default Info-auto-generate-directory to 'if-outdated -- Adrian Aichner
-- improve printer handling -- Andy Piper, Mike Alexander, Adrian Aichner
-- mark buffer as modified when changing coding system -- Andy Piper
-- minor mode mode-line-strings now customizable -- John Paul Wallington
   isearch-mode, abbrev-mode, overwrite-mode, auto-fill-mode,
   gnuserv-mode, defining-kbd-macro-mode, font-lock-mode, view-mode
-- search the core etc/ for package index if not in ~/.xemacs/ -- Steve Youngs
-- support sub-expression replacement in replace-match -- Torsten Duwe
-- support user {site,infodock}-packages hierarchies -- Michael Sperber
-- truncate-partial-width-windows now applied in redisplay -- Ben Wing
-- use version-specific name for root testing -- Michael Sperber
   Eg, /usr/local/lib/xemacs-21.5.4.  Fixes common "can't find root" bug,
   but run-in-place XEmacs won't find installed packages.

-- HTML docs from Texinfo sources -- Adrian Aichner
-- document fix for Motif related crashes (Sun/Solaris) -- Robert Pluim
-- improve package system documentation -- Stephen Turnbull
-- new Japanese translation of xemacs.1 -- Kazuo Oishi
-- update developer personal info -- Jan Vroonhof, Michael Diers
-- many doc fixes and improvements, sorry about the credits :-(

-- alias `interactive-form' to `function-interactive' -- John Paul Wallington
-- etags to Potorti` version 14.28. -- Yoshiki Hayashi
-- mark-paragraph - added optional argument -- John Paul Wallington

-- arch-specific files go under ${libdir}, not ${datadir} -- Jered Floyd
-- configure recognizes LDFLAGS and adds to top Makefile -- Lutz Jaenicke
-- eliminate bogus check for Athena widgets -- Alexey Mahotkin
-- omit -Wshadow when compiling with g++ -- Ben Wing
-- use the ld reported by gcc, not gcc -- Andrew Begel
-- work around lack of support for autoconf 2.5x -- Didier Verna

-- fix "can't Customize standard faces" bug (partially) -- Jan Vroonhof
-- fix "can't close last window" bug -- Adrian Aichner
-- fix "doubled escape" bug in Mule (ISO-2022-7) autosave files -- Kyle Jones
-- fix "fail to save (non-themed) variable customizations" bug -- Andy Piper
-- fix PGP signature handling in package UI -- Steve Youngs
-- fix allocation of module-defined names in symbol table -- Andrew Begel
-- fix conversion of host and network byte order in multicast -- Daiki Ueno
-- fix crash from missing XIM unregister callback on Motif -- Glynn Clements
-- fix crash/infloops in read_key_sequence -- Hirokazu FUKUI
-- fix early dereference crash in decode_buffer -- Torsten Duwe
-- fix handling of negative C times -- Simon Josefsson and Stephen Turnbull
-- fix 'report-xemacs-bug' issues -- Steve Youngs
-- fix several font-lock bugs -- Jan Vroonhof, Andy Piper, Bill Perry
-- fix several package-get bugs -- Steve Youngs
-- fix some slow startups - default with_ipv6_cname=no -- Stephen Turnbull
-- fix unsigned warnings; turn sign-compare warnings on for NT -- Ben Wing
-- fix window_loop iteration across multiple devices -- Darryl Okahata
-- fix/avoid GNU ld -z combreloc lossage -- Stephen Turnbull
-- make sure installed.db gets updated after updating packages -- Andy Piper

-- GTK improvements/fixes -- Bill Perry
   -- add face mappings
   -- fix "can't shut up bell" bug
   -- fix some face initialization bugs
   -- fix subwindow handling
   -- fix yes-or-no-p lossage
   -- improve conformance to internal APIs
   -- munge highlight, zmacs-region, toolbar, and gui-button faces from
      default GtkStyle
   -- remove useless XPM color symbol checks

-- MS Windows improvements/fixes -- Andy Piper
   -- better build portability
   -- change registry key to XEmacs.
   -- add/fix Cygwin handling of URLs and win32 paths
   -- fix focus and event handling in scrollbars
   -- fix get-popup-menu-response bug
   -- improve DDE support
   -- improve netinstaller, especially uninstall and shortcuts
   -- improve popup dialog handling
   -- new directory dialog support
   -- quit if the user cancels in directory dialog
-- Cygwin nox-xpm detection -- Charles Wilson
-- fix compile problems when --with-msw, --with-x=no, --with-tty=no -- Ben Wing
-- fix file handle leak in pipes -- Mike Alexander
-- initial VC.NET support -- Andrew Begel

-- Rename/redefine integral types -- Ben Wing
   -- See src/ChangeLog for details and rationale.
   -- All integral types that measure quantities of anything are signed.
   -- All quantity types boil down to EMACS_INT, except Hashcode,
      which is an unsigned value of the same size as EMACS_INT.
   -- Type names should be relatively short, with the first letter
      capitalized and no underscores if they can be avoided.
   -- "*count" == zero-based quantity.  Includes sizes, offsets, and indexes.
   -- "*bpos" == one-based buffer position.
   -- "Char" refers to internal-format characters, not to the C type "char".
-- CVS: improve .cvsignore files -- Adrian Aichner
-- autoload handling improvements -- Didier Verna
-- improve handling of face inheritance/fallback -- Jan Vroonhof
-- condense repetitive window-system settings to 'win default' -- Bill Perry
-- improve debugging in event-msw.c -- Adrian Aichner
-- rename Menubar-items-truncate-list to Menubar-items-truncate-history
   -- Adrian Aichner
-- rename default package index to 'package-index.LATEST.gpg' -- Steve Youngs
-- unify GUI pixmap handling -- Bill Perry
-- unify toolbar handling across GUI platforms -- Bill Perry

to 21.5.3 "asparagus"
-- Add missing XIM unregister callback on Motif -- Glynn Clements
-- Improve debugging in event-msw.c, fix "can't close last window" bug
   -- Adrian Aichner
-- Improve Info docs for widget.el -- Stephen J. Turnbull
-- Many small bug, typo, and warning fixes -- Ben Wing, Stephen J. Turnbull,
   Adrian Aichner
-- Autoload handling improvements -- Didier Verna
-- More 'report-xemacs-bug' updates -- Steve Youngs
-- Fix unsigned warnings; turn sign-compare warnings on for NT -- Ben Wing
-- Synch configure.usage options with configure -- Peter Brown

to 21.5.2 "artichoke"
-- fixes and improvements -- Ben Wing
   -- etags.c synched to upstream
   -- lisp/term/*.el cleanup
   -- miscellaneous help improvements
   -- transpose-line-up/down maybe moves the region
   -- MS Windows init improvements
   -- add scroll-in-place, jka-compr, efs, some fixes in behavior-defs.el
   -- paths-find-recursive-path: fix error with null EXCLUDE-REGEXP
   -- font-lock-mode: fix problem with buffers starting with a space
   -- make find-library search patch configurable
   -- fix Dired problem with directories containing [] and code that
      destructively modifies an existing string
   -- stop mark_window_as_deleted from deleting information that needs to
      be accessed by set-window-configuration
   -- Lisp object structure rationalization
   -- fix two nasty bugs in the unwinding code
   -- fix mouse wheel/dead window crash under MS Windows
   -- mswindows_utime, close_file_data: fix off-by-one-indirection error
   -- control-G handling fixes for MS Windows
   -- debug-mswindows-events and related code introduced
   -- rearrange the signal-handling code to eliminate the former
      spaghetti logic paths in it; document; fix numerous bugs
   -- maintain the "iconified" state, to fix the "can't delete a frame" bug
   -- use CBufbyte instead of char for error/warning functions
   -- prepare to remove encapsulation
   -- make play_sound_data return an int, like all other such functions
   -- use EMACS_SIGNAL to avoid preprocessing games with signal()
   -- gc-in-window-procedure fixes
   -- Cygwin setitimer fixes
   -- windows shell fixes
   -- more structured errors
   -- MS Windows network stream data corruption fixes
   -- fix ~user file name handling
   -- rename MAX_PATH to standard PATH_MAX
   -- fix error compiling regexps with back-references in them

-- fixes and improvements -- Martin Buchholz
   -- byte optimizer fixes
   -- move alloca twiddling after the feature test definitions, but
      before the first "real" code
   -- internal DECIMAL_PRINT_SIZE macro
   -- s&m elimination: Eliminate the need to define HAVE_PTYS in s&m files
   -- avoid test failure if (temp-directory) is a symlink
   -- handle buggy Sun realloc()

-- GTK fixes -- Bill Perry
   -- GTK popup dialog fix
   -- GTK added to font-window system mappings
   -- gtk-marshal.el updated for new hash.c, and generator fixes,
   -- GTK scrollbar fixes
   -- buttons are now modifiers, so selection with the mouse works again
   -- fix the disappearing GTK scrollbar problem

-- movemail.c uses mkstemp if available -- Karl M. Hegbloom
-- specifiers may now conditionalize on GTK -- Stephen J. Turnbull
-- new hooks for package installation and deletion -- Sean MacLennan
-- locate-library completes and other package UI improvements -- Robert Pluim
-- save-some-buffers doesn't prematurely zap help window -- Michael Sperber
-- MS windows subprocess quoting arguments -- Ben Wing, Dan Holmsand
-- remove side effects from font-lock-compile-keywords -- Daiki Ueno
-- custom-display works on the GTK platform -- Karl Hegbloom
-- mouse-track fixes -- Adrian Aichner, Ben Wing
-- dragdrop fix for windowless events -- Mike Alexander
-- fix `unbalanced parentheses' bug in syntax -- Matt Tucker
-- gpmevent.c header inclusion fixes -- Bill Perry
-- make more glyph code shared across platforms -- Ben Wing, Bill Perry
-- remove lisp_string_set_file_times() because set_file_times() now
   takes Lisp_Object path, instead of char* -- Adrian Aichner and Ben Wing
-- allow preemption on redisplay -- Kirill 'Big K' Katsnelson
-- new, faster implementation of long_to_string -- Hrvoje Niksic
-- Qccl_error: New error -- Yoshiki Hayashi
-- remove support for old beta versions of cygwin -- Ben Wing, Craig Lanning
-- fix crash with an unavailable network printer -- Mike Alexander
-- add support for MacOS X -- Greg Parkin and Martin Buchholz
-- better win9x (including WinMe) support -- Ben Wing, Stephen J. Turnbull
-- fix off-by-one error in EMACS_INT_MAX -- Yoshiki Hayashi

-- warning, style, and doc fixes and improvements
   -- warning fixes -- Ben Wing, Kirill 'Big K' Katsnelson, Martin Buchholz
   -- eliminate numerous C++ errors -- Ben Wing, Martin Buchholz
   -- code style corrections -- Ben Wing, Martin Buchholz
   -- build improvements -- Ben Wing, Martin Buchholz
   -- configure improvements and fixes -- Martin Buchholz, Ben Wing,
      Stephen J. Turnbull
   -- doc updates -- Adrian Aichner, Ben Wing, Alexey Mahotkin, Steve
      Youngs, Stephen J. Turnbull, Yoshiki Hayashi, Steve Youngs, Paul
      Stodghill, Malcolm Purvis, Jim Horning, Nick V. Pakoulin, Kirill
      'Big K' Katsnelson

to 21.5.1 "anise"
-- This release contains a huge pile of changes by Ben Wing, including
   both bug fixes and features.  Highlights:
   -- Many changes to make printing work on Windows
   -- byte-compilation speed improvements
   -- New functions for cleanly eliminating byte-compiler warnings
   -- Remove core bytecompiler warnings
   -- Improve interactive help interface
   -- etags improvements
   -- Better "About XEmacs" page
   -- Windows configury changes
   -- Get QUIT working on Windows
   -- Fix shy group regexp code
   -- etc. etc.

-- The `short-name' argument to make-charset now works correctly 
   -- Yoshiaki Kasahara
-- `custom' changes -- Didier Verna
-- SET_FACE_PROPERTY bug fix -- Jerry James
-- Unix tty configury changes -- Martin Buchholz
-- Fix compile error with g++ on bsdi -- Martin Buchholz
-- Fix crash with xlc -O3 -- Martin Buchholz
-- Fix link error with (pre-release) gcc 3.0 -- Martin Buchholz
-- Fix build error if system has makeinfo 3.12 -- Martin Buchholz
-- Speed up `intern' and hash tables containing strings -- Martin Buchholz
-- Make hash table mapping safe -- Martin Buchholz

Fork from 21.2: 21.5.0 "alfalfa"
-- For changes up to 21.4.0, see etc/NEWS
